<?php

require_once __DIR__ . '/vendor/autoload.php';

use Keedosn\UnityGroupTest\Zoo\Animal\Animal;
use Keedosn\UnityGroupTest\Zoo\Meal\Corn;
use Keedosn\UnityGroupTest\Zoo\Meal\Leaf;
use Keedosn\UnityGroupTest\Zoo\Meal\Steak;
use Keedosn\UnityGroupTest\Zoo\Species\Elephant;
use Keedosn\UnityGroupTest\Zoo\Species\Fox;
use Keedosn\UnityGroupTest\Zoo\Species\SnowLeopard;
use Keedosn\UnityGroupTest\Zoo\Zoo;

$mealCorn = new Corn();
$mealLeaf = new Leaf();
$mealSteak = new Steak();

$zoo = new Zoo();

$fox = new Animal('Lisek', new Fox());
$zoo->add($fox);

echo $fox . PHP_EOL;
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $fox->getName(), $mealCorn->getName(), $fox->fed($mealCorn) ? 'Zjedzone' : 'Odrzucone');
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $fox->getName(), $mealLeaf->getName(), $fox->fed($mealLeaf) ? 'Zjedzone' : 'Odrzucone');
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $fox->getName(), $mealSteak->getName(), $fox->fed($mealSteak) ? 'Zjedzone' : 'Odrzucone');
printf('Czy zwierze ma futro? %s' . PHP_EOL, ($fox->hasFur() ? 'Tak' : 'Nie'));
$fox->clearFur();
echo PHP_EOL;

$elephant = new Animal('Słonik', new Elephant());
$zoo->add($elephant);

echo $elephant . PHP_EOL;
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $elephant->getName(), $mealCorn->getName(), $elephant->fed($mealCorn) ? 'Zjedzone' : 'Odrzucone');
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $elephant->getName(), $mealLeaf->getName(), $elephant->fed($mealLeaf) ? 'Zjedzone' : 'Odrzucone');
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $elephant->getName(), $mealSteak->getName(), $elephant->fed($mealSteak) ? 'Zjedzone' : 'Odrzucone');
printf('Czy zwierze ma futro? %s' . PHP_EOL, ($elephant->hasFur() ? 'Tak' : 'Nie'));
$elephant->clearFur();
echo PHP_EOL;

$sl = new Animal('Leopard', new SnowLeopard());
$zoo->add($sl);

echo $sl . PHP_EOL;
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $sl->getName(), $mealCorn->getName(), $sl->fed($mealCorn) ? 'Zjedzone' : 'Odrzucone');
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $sl->getName(), $mealLeaf->getName(), $sl->fed($mealLeaf) ? 'Zjedzone' : 'Odrzucone');
printf('Karmie %s jedzeniem: %s - %s' . PHP_EOL, $sl->getName(), $mealSteak->getName(), $sl->fed($mealSteak) ? 'Zjedzone' : 'Odrzucone');
printf('Czy zwierze ma futro? %s' . PHP_EOL, ($sl->hasFur() ? 'Tak' : 'Nie'));
$sl->clearFur();
echo PHP_EOL;

echo sprintf('W Zoo przebywa obecnie: %d zwierząt' . PHP_EOL, $zoo->count());
