<?php

namespace Keedosn\UnityGroupTest\Zoo\Animal;

use Keedosn\UnityGroupTest\Zoo\Meal\Meal;
use Keedosn\UnityGroupTest\Zoo\Species\Species;
use Keedosn\UnityGroupTest\Zoo\FoodType\FoodType;

class Animal
{
    private $name = '';

    private Species $species;

    function __construct(string $name, Species $species)
    {
        $this->name = $name;
        $this->species = $species;
    }

    public function __toString()
    {
        return sprintf('%s %s', $this->species->getName(), $this->name);
    }

    public function getName(): string
    {
        return $this->name;
    }

    public function fed(Meal $meal): bool
    {
        if ($this->species->getFoodType()->getType() === FoodType::TYPE_OMNIVOROUS) {
            return true;
        }

        if ($this->species->getFoodType()->getType() === $meal->getType()->getType()) {
            return true;
        }

        return false;
    }

    public function hasFur(): bool
    {
        return $this->species->hasFur();
    }

    public function clearFur(): void
    {
        if ($this->hasFur()) {
            $this->species->clearFur();
            echo 'Futro zostało wyczyszczone' . PHP_EOL;
        }
    }
}
